{bpascal.ru maximal}
Program lab_10_8;
uses
    graph;
type
    vector=array[1..4]of real;
    matrix=array[1..4]of vector;
    figure=array[1..8]of record
                               x,y,z:real
                         end;
const
     matr1:matrix=((1,0,0,0),(0,1,0,0),(0,0,1,0),(0,0,0,1));
var
   t,f:figure;
   dx,dy:integer;

procedure frontal(var a:matrix);
  begin
    a:=matr1;
    a[3,3]:=0;
  end;

procedure horizontal(var a:matrix);
  begin
    a:=matr1;
    a[2,2]:=0;
  end;

procedure profile(var a:matrix);
  begin
    a:=matr1;
    a[1,1]:=0;
  end;

procedure isometric(var a:matrix);
  begin
    a:=matr1;
    a[1,1]:=1/sqrt(2);
    a[1,2]:=-1/sqrt(6);
    a[2,2]:=sqrt(2/3);
    a[3,1]:=-a[1,1];
    a[3,2]:=a[1,2];
    a[3,3]:=0;
  end;

procedure oblique(var a:matrix; alpha,l:real);
  begin
    a:=matr1;
    a[3,1]:=l*cos(alpha);
    a[3,2]:=l*sin(alpha);
    a[3,3]:=0;
  end;

procedure cavalie(var a:matrix);
  begin
    oblique(a,pi/4,1);
  end;

procedure cabine(var a:matrix);
  begin
    oblique(a,arctan(0.5),0.5);
  end;

procedure central(var m:matrix; a,b,c:real);
  begin
    m:=matr1;
    m[3,1]:=a/c;
    m[3,2]:=b/c;
    m[3,3]:=0;
    m[3,4]:=1/c;
  end;

procedure multiply(v:vector; m:matrix; var x:vector);
  var
    i,j:byte;
  begin
    for i:=1 to 4 do
      begin
        x[i]:=0;
        for j:=1 to 4 do
          x[i]:=x[i]+v[j]*m[j,i];
      end;
end;

procedure drawing;
  var
    i:byte;
  begin
    with t[4] do
      moveto(dx+round(x),dy+round(y));
    for i:=1 to 4 do
      with t[i] do
        lineto(dx+round(x),dy+round(y));
    with t[8] do
      moveto(dx+round(x),dy+round(y));
    for i:=5 to 8 do
      with t[i] do
        lineto(dx+round(x),dy+round(y));
    for i:=1 to 4 do
      line(dx+round(t[i].x),dy+round(t[i].y),dx+round(t[i+4].x),dy+round(t[i+4].y));
  end;

var
  gd,gm:integer;
  v:vector;
  m:matrix;
  i,c:byte;
  a,b,k:real;
begin
  writeln('  ஥樨,  㤥 뢥  ⮩ ⢥:');
  writeln('1: ᪠');
  writeln('2: ');
  writeln('3: ');
  writeln('4: 業ࠫ쭠');
  repeat
    readln(c)
  until c in [1..4];
  if c=4 then
    begin
      writeln(' न 業 ஥஢:');
      a:=100; b:=50; k:=100; {readln(a); readln(b); readln(k);}
    end;
  gd:=detect;
  initgraph(gd,gm,'c:\bp\bgi');
  if graphresult<>0 then
    halt;
  with t[1] do
    begin
      x:=0;
      y:=0;
      z:=0;
    end;
  with t[2] do
    begin
      x:=50;
      y:=0;
      z:=0;
    end;
  with t[3] do
    begin
      x:=50;
      y:=0;
      z:=100;
    end;
  with t[4] do
    begin
      x:=0;
      y:=0;
      z:=100;
    end;
  with t[5] do
    begin
      x:=0;
      y:=100;
      z:=0;
    end;
  with t[6] do
    begin
      x:=100;
      y:=100;
      z:=0;
    end;
  with t[7] do
    begin
      x:=100;
      y:=100;
      z:=100;
    end;
  with t[8] do
    begin
      x:=0;
      y:=100;
      z:=100;
    end;
  f:=t;
  frontal(m);
  dx:=100;
  dy:=50;
  for i:=1 to 8 do
    with t[i] do
      begin
        v[1]:=x;
        v[2]:=y;
        v[3]:=z;
        v[4]:=1;
        multiply(v,m,v);
        x:=v[1];
        y:=v[2];
      end;
  drawing;
  t:=f;
  horizontal(m);
  dx:=100;
  dy:=230;
  for i:=1 to 8 do
    with t[i] do
      begin
        v[1]:=x;
        v[2]:=y;
        v[3]:=z;
        v[4]:=1;
        multiply(v,m,v);
        x:=v[1];
        y:=v[3];
      end;
  drawing;
  t:=f;
  profile(m);
  dx:=300;
  dy:=50;
  for i:=1 to 8 do
    with t[i] do
      begin
        v[1]:=x;
        v[2]:=y;
        v[3]:=z;
        v[4]:=1;
        multiply(v,m,v);
        x:=v[3];
        y:=v[2];
      end;
  drawing;
  case c of
    1:isometric(m);
    2:cavalie(m);
    3:cabine(m);
    4:central(m,a,b,k)
  end;
  t:=f;
  dx:=350;
  dy:=300;
  for i:=1 to 8 do
    with t[i] do
      begin
        v[1]:=x;
        v[2]:=y;
        v[3]:=z;
        v[4]:=1;
        multiply(v,m,v);
        x:=v[1]/v[4];
        y:=v[2]/v[4];
      end;
  drawing;
  readln;
  closegraph;
end.
{bpascal.ru maximal}